package frazioniconeccezionieio;

import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectOutputStream;

import prog.io.ConsoleInputManager;
import prog.io.ConsoleOutputManager;

public class Main {
	static ConsoleInputManager in = new ConsoleInputManager();
	static ConsoleOutputManager out = new ConsoleOutputManager();

	private static Frazione[] leggiFrazioni() {
		Frazione f[];
		int n;
		n = in.readInt( "Quante frazioni, padrone? " );
		f = new Frazione[ n ];
		for ( int i = 0; i < n; i++ ) {
			int num = in.readInt( "Numeratore: " );
			int den = in.readInt( "Denominatore: " );
			try {
				f[ i ] = new Frazione( num, den );
			}
			catch ( DenominatoreNulloException e ) {
				out.println( "Hai inserito un numeratore nullo --- riprova!" );
				i--;
			}
		}
		return f;
	}
	
	public static void main( String[] s ) throws FileNotFoundException, IOException {
		char c;
		
		do {
			c = in.readChar( "Che operazione, padrone? " );
		} while ( c != '+' && c != '-' && c != '*' && c != '/' );
		
		Frazione f[] = leggiFrazioni();
		Frazione res = f[ 0 ];
		
		try {
			for ( int i = 0; i < f.length; i++ ) 
				switch( c ) {
					case '+': res = res.piu( f[ i ] ); break;
					case '-': res = res.meno( f[ i ] ); break;
					case '*': res = res.per( f[ i ] ); break;
					case '/': res = res.diviso( f[ i ] ); break;
				}
			out.println( "Risultato = " + res );
		} catch ( DenominatoreNulloException e ) {
			out.println( "Una delle frazioni  nulla!" );
		}

		String file = in.readLine( "Nome del file dove devo salvare i risultati? " );
		ObjectOutputStream oos = new ObjectOutputStream( new FileOutputStream( file ) );
		
		oos.writeChar( c );
		Frazione.salvaFrazioni( oos, f );
		oos.writeObject( res );
		oos.close();
	}
	
}
